<div>
<h3>Registers</h3>

<p><em>Exemoji</em> supports <span id="reg-count"></span> general-purpose 8bit registers:</p>

<section>
    <table class="table">
        <thead>
            <tr>
                <th>Register</th>
                <th>Index</th>
                <th>Special Use</th>
            </tr>
        </thead>
        <tbody id="registers">
        </tbody>
    </table>
</section>

<p>In addition to these, there are two 16 bit registers, the program counter (PC)
and stack pointer (SP), which are affected by specific instructions.</p>

<h3>Immediates</h3>
<section>
    <p>Immediate values can be directly encoded by bytes but this will sometimes result in invalid utf-8 sequences,
    as such there is an emoji alternative to encode immediate values</p>
    <p>A nibble can be represented by one of the following emoji:</p>

    <table class="table">
        <thead>
            <tr>
                <th>Code</th>
                <th>Hex</th>
                <th>Dec</th>
            </tr>
        </thead>
        <tbody id="immediates">
        </tbody>
    </table>

    <p>To represent a full byte (octet), you need to prefix the immediate with
    <span id="immediate-long"></span> followed by two nibble emoji.</p>
</section>

<h3>Instructions</h3>
<section>
    <table class="table">
        <thead>
            <tr>
                <th>Opcode</th>
                <th>Name</th>
                <th colspan="3">Operands</th>
                <th>Description</th>
            </tr>
        </thead>
        <tbody id="instructions">
        </tbody>
    </table>

    <p>Some instructions take 16 bit addresses represented as a pair of operands.
        These are combined by interpreting the first operand as the most significant byte.</p>
</section>

<h3>Interrupts</h3>
<section>
    <table class="table">
        <thead>
            <tr>
                <th>Code</th>
                <th>Effect</th>
            </tr>
        </thead>
        <tbody id="interrupts">
        </tbody>
    </table>
</section>
</div>
